package de.intevation.gnv.exports;

import java.util.Collection;

import java.io.OutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import de.intevation.gnv.geobackend.base.Result;
import de.intevation.gnv.state.exception.StateException;

/**
 * @author Sascha L. Teichmann (sascha.teichmann@intevation.de)
 * @author Ingo Weinzierl (ingo.weinzierl@intevation.de)
 */
public interface Export {

    public interface Profile {
        String toString(int column, String value);
        char      getSeparator();
        char      getEscapeCharacter();
        char      getQuoteCharacter();
        String    getType();
        String    getEncoding();
        String [] getHeader();
    }

    public interface DataCollector {
        String[] getData(Result result)
        throws StateException;
    }

    public void create(
        Profile      profile,
        OutputStream outputStream, 
        Collection   result
    )
    throws IOException, UnsupportedEncodingException, StateException;

}
